package br.usp.ime.pictware.application.album.service;

public class ObservadorNumeroAcessoAlbum {
	
	private static ObservadorNumeroAcessoAlbum instance = new ObservadorNumeroAcessoAlbum();
	
	private ObservadorNumeroAcessoAlbum(){
		
	}
	
	public static ObservadorNumeroAcessoAlbum getInstance(){
		return instance;
	}
	
	public synchronized Long observarNumeroAcessos(Long idAlbum, Long ultimoNumeroAcessos){
		Long novoNumeroAcessos = null;
		while(true){
			novoNumeroAcessos = ManterAlbumService.getInstance().obterNumAcessosAlbum(idAlbum);
			if(!novoNumeroAcessos.equals(ultimoNumeroAcessos)){
				break;
			}
			try {
				this.wait();
			} catch (InterruptedException e) {
				e.printStackTrace();
			}
		}
		return novoNumeroAcessos;
	}
	
	public synchronized void awake(){
		this.notifyAll();
	}
	
}
