package br.usp.ime.pictware.infraestrutura.persistencia.util;

import java.sql.Connection;
import java.sql.DriverManager;
import java.sql.SQLException;

public class ConnectionManager {

	private ConnectionParameters connectionParameters;
	
	private static ConnectionManager instance = new ConnectionManager();
	
	private ConnectionManager(){}
	
	public static ConnectionManager getInstance(){
		return instance;
	}
		
	public void setConnectionParameters(String url, String user, String password){
		this.connectionParameters = new ConnectionParameters(url,user,password);
	}
	
	public Connection openConnection(){
		try{
			return DriverManager.getConnection(connectionParameters.getUrl(),connectionParameters.getUser(),connectionParameters.getPassword()); 
		}catch(SQLException e){
			return null;
		}
	}
	
	public void closeConnection(Connection conn){
		try{
			if (conn != null && !conn.isClosed()){
				conn.close();
			}
		}catch(SQLException e){
			e.printStackTrace();
			System.out.println("No foi possvel fechar conexo");
		}
	}
}
