package br.usp.ime.pictware.web.action.manteralbum;

import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;

import br.usp.ime.pictware.business.album.bo.Album;
import br.usp.ime.pictware.business.assinante.bo.Assinante;
import br.usp.ime.pictware.web.framework.action.Action;
import br.usp.ime.pictware.web.framework.action.ActionForward;
import br.usp.ime.pictware.web.framework.action.ActionMapping;

import java.io.*;
import java.util.logging.Level;
import java.util.logging.Logger;

public class EscreverCapaAction implements Action{

	private static final Logger LOG = Logger.getLogger(EscreverCapaAction.class.getName());
	
	public ActionForward execute(ActionMapping actionMapping,
			HttpServletRequest request, HttpServletResponse response) {
		
		try{
			Assinante assinante = (Assinante)request.getSession().getAttribute("assinante");
			int indexAlbum = Integer.parseInt(request.getParameter("indexAlbum"));
			Album album = assinante.getAlbum(indexAlbum);			
			byte[] bytesArquivo = album.getCapa().getBytesArquivo();
			response.getOutputStream().write(bytesArquivo);
		}catch(IOException e){
			LOG.log(Level.SEVERE, "No foi possvel carregar a capa do album",e);
			e.printStackTrace();
		}
		return actionMapping.findForward(null);
	}
}
