package br.usp.ime.pictware.web.action.manteralbum;

import java.io.IOException;
import java.util.logging.Level;
import java.util.logging.Logger;

import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;

import br.usp.ime.pictware.business.album.bo.Album;
import br.usp.ime.pictware.business.album.bo.Foto;
import br.usp.ime.pictware.web.framework.action.Action;
import br.usp.ime.pictware.web.framework.action.ActionForward;
import br.usp.ime.pictware.web.framework.action.ActionMapping;

public class EscreverFotoAction implements Action{

	private static final Logger LOG = Logger.getLogger(EscreverFotoAction.class.getName());
	
	public ActionForward execute(ActionMapping actionMapping,
			HttpServletRequest request, HttpServletResponse response) {
		
		try{
			Album album = (Album)request.getSession().getAttribute("currentAlbum"); 			
			int indexFoto = Integer.parseInt(request.getParameter("indexFoto"));
			Foto foto = album.getFoto(indexFoto);
			byte[] bytesArquivo = foto.getBytesArquivo();		
			response.getOutputStream().write(bytesArquivo);
		}catch(IOException e){
			LOG.log(Level.SEVERE, "No foi possvel carregar Foto no Album",e);
			e.printStackTrace();
		}		
        return actionMapping.findForward(null);
	}

}
