package br.usp.ime.pictware.web.beans.manterassinante;

import java.util.ResourceBundle;

import javax.faces.application.FacesMessage;
import javax.faces.component.UIComponent;
import javax.faces.component.UIInput;
import javax.faces.context.FacesContext;
import javax.servlet.http.HttpSession;
import br.usp.ime.pictware.application.assinante.service.ManterAssinanteService;
import br.usp.ime.pictware.business.assinante.bo.Assinante;

public class ManterAssinanteBean {

	private String login;
	private String senha;
	private String senhaConfirmada;
	private String nome;
	private String apelido;
	
	private UIInput senhaConfirmadaInput;
	
	public UIInput getSenhaConfirmadaInput() {
		return senhaConfirmadaInput;
	}
	public void setSenhaConfirmadaInput(UIInput senhaConfirmadaInput) {
		this.senhaConfirmadaInput = senhaConfirmadaInput;
	}
	public String getLogin() {
		return login;
	}
	public void setLogin(String login) {
		this.login = login;
	}
	public String getSenha() {
		return senha;
	}
	public void setSenha(String senha) {
		this.senha = senha;
	}
	public String getSenhaConfirmada() {
		return senhaConfirmada;
	}
	public void setSenhaConfirmada(String senhaConfirmada) {
		this.senhaConfirmada = senhaConfirmada;
	}
	public String getNome() {
		return nome;
	}
	public void setNome(String nome) {
		this.nome = nome;
	}
	public String getApelido() {
		return apelido;
	}
	public void setApelido(String apelido) {
		this.apelido = apelido;
	}
	
	public void validateEmail(FacesContext context, UIComponent component, Object value) {
		String email = (String) value;
		
		if (email.indexOf('@') == -1) {
			
			//Recupera a mensagem de erro a partir do bundle
			String errorMessage = getMessageFromBundle(context,"InvalidEmail");
			
			((UIInput)component).setValid(false);
			FacesMessage message = new FacesMessage(errorMessage);
			context.addMessage(component.getClientId(context), message);

		}
	}
		
	public String loginAction(){
		
		FacesContext ctx = FacesContext.getCurrentInstance();
		HttpSession session = (HttpSession)ctx.getExternalContext().getSession(false);
		//request = FacesContext.getCurrentInstance().getExternalContext().getRequest());
		
		ManterAssinanteService manterAssinanteService = ManterAssinanteService.getInstance();
		Assinante assinante = manterAssinanteService.buscarAssinante(login, senha);
	
		if (assinante != null){
			
			session.setAttribute("uid", assinante.getId());
			
			//FIXME: TO BE REMOVED (trabalharemos apenas com o id do usurio na session)
			session.setAttribute("assinante", assinante);
			return "autenticado";
		}
		else{
			session.invalidate();
			
			//Recupera a mensagem de erro a partir do bundle
			String errorMessage = getMessageFromBundle(ctx,"UserNotFound");
			ctx.addMessage(null,new FacesMessage(errorMessage));
			return "nao-autenticado";
		}
		
	}
	
	public String cadastrarAction(){
	
		FacesContext ctx = FacesContext.getCurrentInstance();
		HttpSession session = (HttpSession)ctx.getExternalContext().getSession(false);
			
		//Confirmao da senha
		if (!senhaConfirmada.equals(senha)){
	
			//Recupera a mensagem de erro a partir do bundle
			String errorMessage = getMessageFromBundle(ctx,"WrongSignUpPassword");
			ctx.addMessage(senhaConfirmadaInput.getClientId(ctx),new FacesMessage(errorMessage));

			return "senha-nao-confirmada";
		}
				
		//Incluso (Cadastro)
		Assinante assinante = ManterAssinanteService.getInstance().cadastrarAssinante(login, senha, nome, apelido);
		session.setAttribute("assinante", assinante);
		return "usuario-cadastrado";		
	}
	
	private String getMessageFromBundle(FacesContext ctx, String key){
		ResourceBundle bundle = ResourceBundle.getBundle("messageresource.MessageResource", ctx.getViewRoot().getLocale());  
		String errorMessage = bundle.getString(key);
		return errorMessage;
	}
}
