package br.usp.ime.pictware.web.framework.action;

import java.io.IOException;

import javax.servlet.ServletContext;
import javax.xml.parsers.DocumentBuilder;
import javax.xml.parsers.DocumentBuilderFactory;
import javax.xml.parsers.ParserConfigurationException;

import org.w3c.dom.Document;
import org.w3c.dom.Node;
import org.w3c.dom.NodeList;
import org.xml.sax.SAXException;

public class ActionMapping {

	private ServletContext servletContext;
	private String actionName;
	
	public ActionMapping(ServletContext servletContext, String actionName){
		this.servletContext = servletContext;
		this.actionName = actionName;
	}
	
	public ActionForward findForward(String forwardName){
		
		if (forwardName == null){
			return null;
		}
		
		try{
			String jspName = null;
			
			DocumentBuilderFactory dbf = DocumentBuilderFactory.newInstance();
			DocumentBuilder db = dbf.newDocumentBuilder();		
			Document doc = db.parse(servletContext.getResourceAsStream("/WEB-INF/framework-config.xml"));
			NodeList actionNodes = doc.getElementsByTagName("action");
				
			search:
			for(int i=0; i<actionNodes.getLength(); i++){
				
				Node actionNode = actionNodes.item(i);				
				if (actionNode.getAttributes().getNamedItem("name").getNodeValue().equals(actionName)){
					
					NodeList forwardNodes = actionNode.getChildNodes();					
					for (int j=0; j<forwardNodes.getLength(); j++){
						
						Node forwardNode = forwardNodes.item(j); 
						
						//Verify whether the node is not a Text Node
						if (forwardNode.getNodeType() != Node.TEXT_NODE){
						
							if (forwardNode.getAttributes().getNamedItem("name").getNodeValue().equals(forwardName)){
						
								jspName = forwardNode.getAttributes().getNamedItem("path").getNodeValue();
								break search;
							}
						}						
					}
				}
			}
			
			if (jspName == null){
				//TODO: Disparar exceo
			}
			
			ActionForward actionForward = new ActionForward(jspName);
			return actionForward;
			
		}catch(Exception e){
			e.printStackTrace();
			return null;	
		}		
	}	
	
}
