package br.usp.ime.pictware.web.listener;

import java.util.logging.Level;
import java.util.logging.Logger;

import javax.servlet.ServletContextEvent;
import javax.servlet.ServletContextListener;

import br.usp.ime.pictware.infraestrutura.persistencia.util.ConnectionManager;

/**
 * Application Lifecycle Listener implementation class DataSourceListener
 *
 */
public class DataSourceListener implements ServletContextListener {

    /**
     * Log.
     */
    private static final Logger LOG = Logger.getLogger(DataSourceListener.class.getName());
	
    /**
     * Default constructor. 
     */
    public DataSourceListener() {
    }

	/**
     * @see ServletContextListener#contextInitialized(ServletContextEvent)
     */
    public void contextInitialized(ServletContextEvent servletContextEvent) {
   		LOG.log(Level.INFO,"Carregando e registrando driver JDBC p/ MySQL");
    		
    	try {
    		//TODO: Externalizar configuracoes
			Class.forName("com.mysql.jdbc.Driver");		
			String url = "jdbc:mysql://pcgerosa.ime.usp.br:3306/pictware";
			String user = "pictware";
			String password = "ware";
			ConnectionManager.getInstance().setConnectionParameters(url, user, password);				
			
			LOG.log(Level.INFO,"Driver JDBC p/ MySQL carregado com sucesso");
		} catch (ClassNotFoundException e1) {
			LOG.log(Level.SEVERE,"Driver JDBC p/ MySQL nao encontrado");
		}			
    }

	/**
     * @see ServletContextListener#contextDestroyed(ServletContextEvent)
     */
    public void contextDestroyed(ServletContextEvent arg0) {
    }
	
}
