package br.usp.ime.pictware.web.servlet;


import java.io.IOException;
import java.io.PrintWriter;

import javax.servlet.ServletException;
import javax.servlet.http.HttpServlet;
import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;

import br.usp.ime.pictware.application.album.service.ObservadorNumeroAcessoAlbum;
import br.usp.ime.pictware.business.album.bo.Album;

/**
 * Servlet implementation class VerificarNumeroAcessoAlbum
 */
public class VerificarNumeroAcessoAlbumServlet extends HttpServlet {
		
	private static final long serialVersionUID = 3194066451574709646L;
	
	private String delimitador = "delimitador";
       
    protected void doGet(HttpServletRequest request, HttpServletResponse response) throws ServletException, IOException {
		
    	System.out.println("Reached the Servlet!");
    	
    	iniciaMultipartResponse(response);
				
		Album album = (Album)request.getSession().getAttribute("currentAlbum");
    	Long idAlbum = album.getId();
		Long ultimoNumeroAcessos = null;
		
		while(true){
			Long numeroAcessos = ObservadorNumeroAcessoAlbum.getInstance().observarNumeroAcessos(idAlbum,ultimoNumeroAcessos);
			atualizarContador(numeroAcessos,response);
			ultimoNumeroAcessos = numeroAcessos;			
		}
	}

	protected void doPost(HttpServletRequest request, HttpServletResponse response) throws ServletException, IOException {
		doPost(request, response);
	}
	
	private void iniciaMultipartResponse(HttpServletResponse resp) throws IOException {
		resp.setHeader("Content-type", "multipart/x-mixed-replace;boundary=\"" + delimitador + "\"");		
		resp.getWriter().write("--" + delimitador + "\n");
	}

	private void atualizarContador(Long numeroAcessos,HttpServletResponse resp) throws IOException {
		
		PrintWriter writer = resp.getWriter();
		
		//Escreve a resposta no formato JSON
		writer.write("Content-type: text/plain\n\n");
		writer.write("{\"numeroAcessos\": " + numeroAcessos + "}" + "\n");
		
		resp.flushBuffer();
		writer.println("--" + delimitador);
		resp.flushBuffer();
	}	

}
